#!/bin/bash

[ -d src ] || { echo "Directory src not found!"; exit 1; }

choose(){
	DEFAULT_SELECTION="$1"
	echo "-) $DEFAULT_SELECTION (<Ctrl-D> default)"
	select CHOICE in "$@" "exit"; do
		[ "$CHOICE" == "exit" ] && return 1;
		break;
	done
	[ -z "$CHOICE"  -o -z "${CHOICE// }" ] && CHOICE="$DEFAULT_SELECTION" # if <Ctrl-D>, TASK=null
	# echo "You selected '$CHOICE'"
	return 0
}

uninstall-local(){
	make uninstall-local
}
uninstall-system(){
	make uninstall
}
install-local(){
	make clean
	make install-local${MAKE}
}
install-system(){
	make clean
	make install${MAKE}
}
create-doc(){
	txt2html README -tf -noec > readme.html
}

if [ "$1" = "doc" ] || [ ! -f readme.html ]; then
	create-doc
	exit 0
fi

echo "Tablaunch `grep -o "VERSION=.*" src/tablaunch.c`"
echo "------------------------"
choose install uninstall || { echo "Quiting."; exit 0; }
echo "You selected $CHOICE"
ACTION=$CHOICE
if [ "$ACTION" == "install" ]; then
	echo 
	echo "Which image library do you want to use?
	Imlib2 renders better quality enlarged images if you don't specify the large icons."
	which imlib-config  > /dev/null || echo "       Note: You do not seem to have Imlib1."
	which imlib2-config > /dev/null || echo "       Note: You do not seem to have Imlib2."
	choose imlib1 imlib2 || { echo "Quiting."; exit 0; }
	echo "You selected $CHOICE"
	[ "$CHOICE" == "imlib2" ] && MAKE=".imlib2"
fi

echo
echo "Where do you want to $ACTION it?
	local = $HOME/bin
	system = /usr/local/bin or \$PREFIX/bin"
choose local system || { echo "Quiting."; exit 0; }
INSTALL=$CHOICE
echo "You selected $INSTALL"

echo
read -p "Ready to $ACTION? (hit Ctrl-C to quit or Enter to continue)"

if [ ! -d "build" ]; then
	mkdir build
	cd build
	lndir ../src
else
	cd build
fi
echo
echo "Performing ${ACTION} ..."
: echo ": ${ACTION}-${INSTALL} where make=${MAKE}"
${ACTION}-${INSTALL}

echo "Done"
cd ..

